#! /usr/bin/python3

try :
    import sys, os
    import subprocess
except :
    raise
else :
    def rpm_format_strset(s) :

        # Borrowed from lib.req:
        # For the number of symbols in the range 2^{m-1}..2^m-1,
        # use m+10 bits per symbol.  Upper bound on the error rate
        # is 2^{-10} (about 0.1%).
        import math
        bpp = math.log(len(s)) / math.log(2) + 11

        mksetP = subprocess.Popen(['/usr/lib/rpm/mkset', '%d' % bpp],
                                  stdin=subprocess.PIPE,
                                  stdout=subprocess.PIPE,
                                  universal_newlines=True)
        return mksetP.communicate(input='\n'.join(s))[0].strip()

    def get_path_constraint(rpm_br,rpm_path) :

        # It is possible that sys.path has RPM_BUILD_ROOT-prefixed entries,
        # e.g. if we build python itself and RPM_PYTHON is redefined
        #rpm_br=os.path.normpath(os.getenv('RPM_BUILD_ROOT',""))
        rpm_br=os.path.normpath(rpm_br)
        if rpm_br in ['','/','.'] :
            rpm_br=''
            br_len = 0
        else :
            br_len = len(rpm_br)
        #print rpm_br
        def strip_buildroot(p) :
            if p.startswith(rpm_br+'/') :
                return p[br_len:]
            return p
        sys_path = [ strip_buildroot(p) for p in sys.path ]

        # Additional paths where our deps are allowed to be located:
        #rpm_path = os.getenv('RPM_PYTHON3_IMPORT_PATH','').split()
        rpm_path = [ p for p in rpm_path if not (p in sys_path) ]
        if 0 == len(rpm_path) :
            # Only standard search path is allowed to satisfy our deps;
            # emulate the most strong constraint (like "empty set" semantically):
            return '< 0'
        else :
            # An extended set of paths is allowed to satisfy our deps.
            return '<= %s' % rpm_format_strset(rpm_path)

    if __name__ == '__main__' :
        print(get_path_constraint(sys.argv[1],sys.argv[2:]))
